/*
 * CommunityStoresView.java
 *
 * Created on 25 de agosto de 2004, 17:11
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import java.util.Vector;

import com.fenalco.entities.StoreList;
import com.fenalco.entities.User;

import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.StoreListViewSupplier;

/**
 * Este servlet prepara la vista de los establecimientos de un minorista para
 * que el proveedor pueda seleccionar los que desea agregar a la comunidad
 * seleccionada.
 * 
 * @author Néstor Romero León
 */
public class CommunityStoresView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración.
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este servlet crea un objeto del tipo <CODE>StoreList</CODE> pasándole
	 * como parámetro un identificador de minorista que será el filtro que se
	 * utilizará en este listado.
	 * 
	 * Luego el objeto <CODE>StoreList</CODE> es utilizado como parámetro para
	 * crear un objeto de tipo <CODE>CommunityStoresListView</CODE>
	 * 
	 * Este último objeto es enviado por medio de request, asignándolo como
	 * atributo, hacia establecimientos.jsp.
	 * 
	 * Para la realización de esta operación se debe tener en cuenta que sólo se
	 * pueden cargar los establecimientos del minorista que no esten asignados a
	 * la comunidad actual.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet.
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo PrintWriter de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url;
		String message;

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
	
			}
			else
			{
	
                                // criterios de paginación
				int pagina = 1;
				int resultadosPagina = 20;
				int paginas; // numero total de páginas
				int inicio = 0; // numero del primero registro que se va a mostrar
				int fin = 9; // numero del último registro que se va a mostrar
				int total; // numero total de resultados
                                
                                String temp = request.getParameter("page");
                                if( temp == null ){
                                    
                                    pagina = 1;
                                    
                                }else{
                                
                                    pagina = Integer.parseInt( temp );
                                    
                                }
                                
                                pagina = (pagina < 1)? 1 : pagina;
                                temp = request.getParameter( "pageResults" );
                                
                                if( temp == null ){
                                    
                                    resultadosPagina = 20;
                                    
                                }else{
                                
                                    resultadosPagina = Integer.parseInt( temp );
                                    
                                }
                                
                                resultadosPagina = (resultadosPagina < 1)? 20 : resultadosPagina;
                                
                                
				int shopKeeperId = new Integer(request.getParameter("shopKeeperId")).intValue();
				int communityId = new Integer(request.getParameter("communityId")).intValue();
				StoreList storeList = new StoreList();
                                
                                String storeName = request.getParameter( "storeName" );
                                
                                if( storeName == null ){
                                    storeName="";
                                }
				storeList.getNonCommunityStores(shopKeeperId, storeName,communityId);
				//CommunityStoresListView communityStoresListView = new
				// CommunityStoresListView(stores);
                                
                                Vector results = new Vector();
                                total = storeList.getStores().size();    
                                
                                paginas = (int) Math.ceil((double) total / (double) resultadosPagina);
                                
				if( pagina > paginas ){
					pagina = paginas;
				}
                                
				inicio = (pagina - 1) * resultadosPagina;
				fin = pagina * resultadosPagina;
				inicio = (inicio < 0) ? 0 : inicio;
                                
				if( fin > total ){
					fin = total;
				}
                                
				for( int i = inicio; i < fin; i++ ){
					results.addElement( storeList.getStores().elementAt(i) );
                                }
                                
                                storeList.setStores( results );
                                
				StoreListViewSupplier view = new StoreListViewSupplier(storeList);
	
				if( view == null )
				{
					//Fallo al cargar el listado de establecimientos
					url = "/proveedor/establecimientos.jsp";
					//message = "Fallo al cargar el listado de establecimientos";
					message = MessageBuilder.buildMessage(9);
	
				}
				else
				{
					//Todo OK
					url = "/proveedor/establecimientos.jsp";
					//message = "La carga del listado finalizó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("view", view);
					request.setAttribute("communityId", new Integer(communityId));
				}
                                
                                /// información de la paginacion
                                inicio++; // para no arrancar desde 0
                                inicio = (fin == 0) ? 0 : inicio;
                                request.setAttribute("firstRow", inicio + "");
                                request.setAttribute("lastRow", fin + "");
                                request.setAttribute("total", total + "");
                                request.setAttribute("page", pagina + "");
                                request.setAttribute("pages", paginas + "");
                                request.setAttribute("pageResults", resultadosPagina + "");
			}
	    }
	    catch( Exception e )
	    {
                e.printStackTrace();
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet.
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo PrintWriter de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet.
	 * @throws ServletException
	 *             Excepción de fallo en la operación del servlet.
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura por medio del
	 *             flujo PrintWriter de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna una breve descripción del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}